#ifndef _Document_h
#define _Document_h

/*
 *  subtitle editor
 *	http://kitone.free.fr/subtitleeditor/
 *
 *  Copyright @ 2005-2006, IDJAAD Djamel (aka Kitone)
 *
 *  Contact: kitone at free point fr
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See gpl.txt for more information regarding the GNU General Public License.
 *
 *
 *  \file
 *  \brief 
 *  \author IDJAAD Djamel (kitone at free point fr)
 */

#include "SubtitleModel.h"
#include "StyleModel.h"
#include "ScriptInfo.h"


class Document
{
public:
	Document();
	~Document();

	/*
	 *
	 */
	void clear();

	/*
	 *	utilise simplement l'extention pour determiner quel type de fichier
	 *	".srt" ou ".ssa"
	 *	en cas d'erreur, retourne ssa
	 */
	Glib::ustring getFormat();
	
	/*
	 *
	 */
	bool open(const Glib::ustring &filename);

	/*
	 *
	 */
	bool save(const Glib::ustring &filename, bool rename=true);

public:
	ScriptInfo m_scriptInfo;
	Glib::RefPtr<SubtitleModel>		m_subtitleModel;
	Glib::RefPtr<StyleModel>			m_styleModel;
	//Glib::RefPtr<NameModel>				m_nameModel;

	// filename movie, ...
	Glib::ustring filenameDocument;
	Glib::ustring filenameMovie;
};

#endif//_Document_h

