/*
 *  subtitle editor
 *	http://kitone.free.fr/subtitleeditor/
 *
 *  Copyright @ 2005-2006, IDJAAD Djamel (aka Kitone)
 *
 *  Contact: kitone at free point fr
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  See gpl.txt for more information regarding the GNU General Public License.
 *
 *
 *  \file
 *  \brief 
 *  \author IDJAAD Djamel (kitone at free point fr)
 */

#include <iostream>
#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/table.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/box.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/dialog.h>
#include <gtkmm/label.h>

#include "SubtitleView.h"
#include "SubtitleEditor.h"

#include <glibmm/spawn.h>

#include <glibmm.h>

#include <gtkmm/liststore.h>
#include <gtkmm/stock.h>

#include "ASpell.h"
#include "SpellDialog.h"
#include <config.h>

#include "SubtitleSSA.h"

/*
 *
 */
class SubtitleOption : public Glib::OptionGroup
{
public:
  SubtitleOption();

public:
  Glib::ustring	m_subtitlefile;
  Glib::ustring m_moviefile;
};

/*
 *
 */
SubtitleOption::SubtitleOption()
:Glib::OptionGroup("subtitleeditor", "description ....", "help...")
{
  /*
  Glib::OptionEntry entry1;
  entry1.set_long_name("version");
  entry1.set_short_name('v');
  entry1.set_description(VERSION);
  add_entry(entry1, m_subtitlefile);
  */
  Glib::OptionEntry entry2;
  entry2.set_long_name("sub");
  entry2.set_short_name('s');
  entry2.set_description("The subtitle file");
  add_entry(entry2, m_subtitlefile);

  Glib::OptionEntry entry3;
  entry3.set_long_name("movie");
  entry3.set_short_name('m');
  entry3.set_description("The movie file");
  add_entry(entry3, m_moviefile);
}

#include "utility.h"

/*
 *
 */
int main(int argc, char *argv[])
{
	/*
	unsigned int rgb = 15329769;

	Gdk::Color gdk_color;

	color2rgb(rgb, gdk_color);

	unsigned int value = 0;
	rgb2color(gdk_color, value);

	std::cout << "rgb   : " << rgb << std::endl;
	std::cout << "value : " << value << std::endl;
	return 0;
	*/
	Gtk::Main kit(argc, argv);

  SubtitleOption options;
  Glib::OptionContext context;
  
  context.set_main_group(options);

  try
  {
    context.parse(argc, argv);
  }
  catch(const Glib::Error &ex)
  {
    std::cout << "SubtitleEditor::Exception: " << ex.what() << std::endl;
    return 1;
  }

  SubtitleEditor editor(options.m_subtitlefile, options.m_moviefile);
	
  kit.run(editor);

  return 0;
}

